//******************************************************************************
// 
//******************************************************************************
#include <io.h>

#define orange  16
#define purple1 2
#define purple2 4
#define blue    8
#define green   1

#define upbutton    128
#define enterbutton 64
#define downbutton  32 

void devset(volatile char reg, volatile char setting);
void send(int data);
void wait(void);          //delay function
void swait(void);
void flashy(void);
void spi_send(char data);
void display(char data[]);

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT

  static unsigned int results[128];  
  static unsigned char message[] = {0x16,0x26,0x36,0x46};
  //static unsigned int A1results[100];  
  //static unsigned int A2results[100];  
  //static unsigned int A3results[100];  

  static unsigned int A0results;
  static unsigned int A1results;
  static unsigned int A2results;
  static unsigned int A3results;

  //static char message[] = {"Hello World"};
  static char highB, lowB;

  volatile unsigned int i, x, z, index, tempdata, button, exef, stop;

  P1DIR = 0xFF;
  P1OUT = 0x01;
  
  P3SEL |= 0x30;                            // P3.4,5 = USART0 TXD/RXD
  
  P4DIR=0xFF;
  P4SEL=0x00;                               //control lines
  P4OUT=0x00;
  
  P5SEL |= 0x0E;                            // P5.1,2,3 SPI option select
  P5DIR |= 0x0B;
  P5OUT |= 0x01;                            // unselect memory chip  
		
  P6SEL = 0x0F;                             // Enable A/D channel inputs

  P2DIR = 0x1F;                             //LEDs and buttons
  P2OUT = 0;

  
  index = 0;
  x = 0;
  tempdata = 0;
  z = 0;
  exef = 0;

  BCSCTL1 &= ~XT2OFF;                       // XT2on

  do
  {
  IFG1 &= ~OFIFG;                           // Clear OSCFault flag
  for (i = 0xFF; i > 0; i--);               // Time for flag to set
  }
  while ((IFG1 & OFIFG));                   // OSCFault flag still set?

  BCSCTL2 |= SELM_2 + SELS;                 // MCLK = SMCLK = XT2 (safe)

  //UART0
  ME1 |= UTXE0 + URXE0;                     // Enable USART0 TXD/RXD
  UCTL0 |= CHAR;                            // 8-bit character
  UTCTL0 |= SSEL1;                          // UCLK = SMCLK
  UBR00 = 0xA0;                             // 8Mhz/19200 ~ 417
  UBR10 = 0x01;                             //
  UMCTL0 = 0x00;                            // no modulation
  UCTL0 |= 0x01;                            // Initialize USART state machine
  TXBUF0 = 0x00;	
  UCTL0 &= 0x10;


  //ADC
  ADC12CTL0 = ADC12ON+MSC+SHT0_8;           // Turn on ADC12, extend sampling time
                                            // to avoid overflow of results
  ADC12CTL1 = SHP+CONSEQ_3;                 // Use sampling timer, repeated sequence
  //ADC12CTL1 |= 0xE0;
  ADC12MCTL0 = INCH_0;                      // ref+=AVcc, channel = A0
  ADC12MCTL1 = INCH_1;                      // ref+=AVcc, channel = A1
  ADC12MCTL2 = INCH_2;                      // ref+=AVcc, channel = A2
  ADC12MCTL3 = INCH_3+EOS;                  // ref+=AVcc, channel = A3, end seq.
  //ADC12IE = 0x08;                         // Enable ADC12IFG.3
  ADC12CTL0 |= ENC;                         // Enable conversions
   
  //SPI
  ME2 |= USPIE1;                            // Module enable
  UCTL1 = CHAR + SYNC + MM + SWRST;         // 8-bit, SPI, Master
  UTCTL1 = SSEL1 +SSEL0 + STC;              // Polarity, SMCLK, 3-wire
  //UTCTL1 = CKPL + SSEL1 +SSEL0 + STC;       // Polarity, SMCLK, 3-wire
  UBR10 = 0x64;                             // SPICLK = SMCLK/2
  UBR11 = 0x00;
  UMCTL1 = 0x00;
                             
  UCTL1 &= ~SWRST;                          // SPI enable

  
  
  P2OUT = 0xFF;                             //LED test 
                                            //configure control lines
  devset(1,0);                              //self test on
  devset(2,0);                              //disable sleep
  devset(3,0);                              //1.5g selected
  devset(4,0);                              //reset memory
  wait();
  devset(4,1);                              //set memory to run
  
  ADC12CTL0 |= ADC12SC;                     // Start conversion	
	  //main loop
  
  
  
  for(;;)
  {
   
  // wait();
  // wait();
   display(message);
   //wait();
  // wait();
	while(!exef) 
		{
	      button = P2IN & 0xE0;
	
	      if(upbutton) 
		     {
	        //increament command 
             z = z + 1;
	         }
	      if(downbutton) 
		    {
	        //decrement command	
			z = z + 1;
	        }
		  if(enterbutton) 
		    {
            //extcute command
			exef = 1;
	        }
	      if(z < 4) 
		    {
	         z = 0;
	        }
	     }
	//run main program
	//command 1 LED's off
	//command 2 exe main program
	//command 3 download data
	//command 4 erase all of external memory

	switch(z) 
	  {
		
		case 1:
		P2OUT = 0;   //turn off LED's
		break;

		case 2:
		button = P2IN & 0xE0;
		while(!(button&0x40)) 
		     {
		      while(!(ADC12IFG & 0x08));
		      A0results = ADC12MEM0;             // Move A0 results, IFG is cleared
		      A1results = ADC12MEM1;             // Move A1 results, IFG is cleared
		      A2results = ADC12MEM2;             // Move A2 results, IFG is cleared
		      A3results = ADC12MEM3;             // Move A3 results, IFG is cleared

		      results[index] = A0results;        //move results to TX buffer
		      index = index + 1;                 // Increment results index
			  results[index] = A1results;
			  index = index + 1;                 // Increment results index
			  results[index] = A2results;
			  index = index + 1;                 // Increment results index
			  results[index] = A3results;

			if(index < 128) 
			  {
			   for(i=0;i<128;i++) 
			      {
			       lowB = results[i];    //try?
			       highB = results[i] >> 8;
			       spi_send(lowB);
			       spi_send(highB);
				   }
			   index = 0;
			  }
			flashy();
			}
		break;
		
		default:
		{
		break;
		}
		
	}
			


   }

} 
 
void display(char data[])
{
	char message[] = {0x11,0x11,0x11,0x11};
	volatile int i;
	P1OUT = 0x00;
    for(i=0;i<5;i++)
		{
		P1OUT = 0x00;
		while ((UTCTL1 & TXEPT) ==0);
	    U1TXBUF = message[i];
		P1OUT = 0x01;
		}		
}

void spi_send(char data)
{
	 while ((UTCTL1 & TXEPT) ==0);
	 U1TXBUF = data;
	//while ((IFG2 & URXIFG1)==0);
}

void wait(void)          //delay function
{
  volatile int i;        //declare i as volatile int
  for(i=0;i<32000;i++);  //repeat 32000 times
 
}

void swait(void)
{
  volatile int i;        //declare i as volatile int
  for(i=0;i<20;i++);  //repeat 2000 times
}

void send(int data)
{
	volatile unsigned char out[] = {0x00,0x00,0x0D} , temp;
	volatile int i;
	//out[0] = ',';
	out[2] = 0x0D; 
	out[0] = data & 0x00FF;
	temp = data & 0xFF00;
	out[1] = temp >> 8;
	
	for(i=0;i<3;i++)
		{
		while(!(UTCTL0 & 0x01));
		TXBUF0 = out[i];
		}
}
	
void flashy(void)       //flashes the led's 
{
	P2OUT |= orange + green;     
	swait();
	P2OUT &= orange;
	swait();
	P2OUT |= orange + green;
	
	P2OUT = 0;
	wait();
	wait();
	P2OUT |= orange + purple1;     
	swait();
	P2OUT &= orange;
	swait();
	P2OUT |= orange + purple1;
	
	P2OUT = 0;
	wait();
	wait();
	P2OUT |= orange + blue;     
	swait();
	P2OUT &= orange;
	swait();
	P2OUT |= orange + blue;
	
	P2OUT = 0;
	wait();
	wait();
	P2OUT |= orange + purple2;     
	swait();
	P2OUT &= 0;
	swait();
	P2OUT |= orange + purple2;
	
	P2OUT = 0;
	wait();
	wait();
	wait();
	P2OUT |= orange;					
}
	
void devset(volatile char reg, volatile char setting)
{
  switch(reg)
		{
		case 0x01:
		//self test
		if(setting)
			{
			P4OUT=P4OUT | 0x01; //self test on
			}
		else
			{
			P4OUT=P4OUT & 0xFE; //self test off
			}
		break;
		
		case 0x02:
		//sleep accelerometer
		if(setting)
			{
			P4OUT=P4OUT & 0xFD;  //enable sleep
			}
		else
			{
			P4OUT=P4OUT | 0x02; //dis enable sleep
			}
		break;
		
		case 0x03:
		//g-select
		if(setting)
			{
			P4OUT=P4OUT | 0x04;  //6g range
			}
		else
			{
			P4OUT=P4OUT & 0xFB; //1.5g range
			}
		break;
		
		case 0x04:
		//memory chip reset
		if(setting)
			{
			P4OUT = P4OUT | 0x08;  //normal run
			}
		else
			{
			P4OUT = P4OUT & 0xF7;  //reset
			}
		break;
			
		default:
		{
		break;
		}
		
	}
}